﻿package cust_Modules.Controls
{
    import flash.display.*;
    import flash.events.*;
	import cust_Modules.Controls.ButtonEvents.*
    import flash.geom.Rectangle;

    public class Button extends Control
    {
        public var pressed:Boolean = false;
        protected var buttonWidth:int;
        protected var buttonHeight:int;
        protected var background:MovieClip;
        public var textLabel:Label;
		public var pressedf:Function = null;
		public var pressactionf:Function = null;

        public function Button(param1:Number, param2:Number, param3:String)
        {
            this.background = new MovieClip();
            addChild(this.background);
            this.buttonWidth = param1;
            this.buttonHeight = param2;
            this.textLabel = new Label(this.buttonWidth, this.buttonHeight, param3);
            addChild(this.textLabel);
            this.setLabel(param3);
            return;
        }// end function

        public function get label() : String
        {
            return this.textLabel.getLabel();
        }// end function

        public function setTextSize(param1:int)
        {
            this.textLabel.setTextSize(param1);
            this.textLabel.y = (this.buttonHeight - param1) / 2 - 2;
            return;
        }// end function

        public function setLabel(param1:String)
        {
            this.textLabel.setLabel(param1);
            return;
        }// end function

        override protected function controlAdded(event:Event)
        {
            addEventListener(Event.ENTER_FRAME, this.tick);
            addEventListener(MouseEvent.MOUSE_DOWN, this.clicked, true);
            return;
        }// end function

        override protected function controlRemoved(event:Event)
        {
            removeEventListener(Event.ENTER_FRAME, this.tick);
            removeEventListener(MouseEvent.MOUSE_DOWN, this.clicked, true);
            return;
        }// end function

        protected function clicked(event:MouseEvent) : void
        {
            this.pressed = true;
			if(pressactionf != null) pressactionf();
            fadeTicks = fadeTicksMax;
            this.textLabel.tf.textColor = glyphClickCol;
            stage.addEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
			addEventListener(Event.ENTER_FRAME, this.repeatf);
            return;
        }// end function

        protected function mouseReleased(event:MouseEvent) : void
        {
            if (this.pressed)
            {
                dispatchEvent(new ButtonClickedEvent(this, hover));
				removeEventListener(Event.ENTER_FRAME, this.repeatf);
                this.textLabel.tf.textColor = hover ? (glyphHoverCol) : (glyphIdleCol);
                this.pressed = false;
            }
            stage.removeEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
            return;
        }// end function

		public function repeatf(event:Event) : void
		{
			if(pressedf != null) pressedf();
		}
		
		
        public function tick(event:Event) : void
        {
            if (!this.pressed)
            {
                this.textLabel.tf.textColor = hover ? (glyphHoverCol) : (glyphIdleCol);
            }
            this.refreshButton();
            return;
        }// end function

        protected function refreshButton() : void
        {
            ControlGraphics.drawRect(this.background, new Rectangle(0, 0, this.buttonWidth, this.buttonHeight), backgroundIdleCol, 0, 1, 0, 0, true);
            ControlGraphics.drawRect(this.background, new Rectangle(0, 0, this.buttonWidth, this.buttonHeight), backgroundHoverCol, 0, fadeTicks / fadeTicksMax, 0, 0, false);
            ControlGraphics.drawRect(this.background, new Rectangle(0, 0, this.buttonWidth, this.buttonHeight), backgroundClickCol, outlineCol, this.pressed ? (1) : (0), outlineOpacity, outlineThickness, false);
            return;
        }// end function

    }
}
