﻿package Modules.Controls
{
    import flash.display.*;
    import flash.events.*;

    public class Checkbox extends Control
    {
        protected var checkShapePoints:Array;
        protected var checked:Boolean = false;
        protected var pressed:Boolean = false;
        protected var checkboxWidth:int;
        protected var checkboxHeight:int;
        protected var background:MovieClip;
        protected var check:MovieClip;

        public function Checkbox(param1:Number, param2:Number)
        {
            this.checkShapePoints = new Array();
            this.background = new MovieClip();
            this.check = new MovieClip();
            this.checkboxWidth = param1;
            this.checkboxHeight = param2;
            this.setupPoints();
            addChild(this.background);
            addChild(this.check);
            return;
        }// end function

        override protected function controlAdded(event:Event)
        {
            addEventListener(Event.ENTER_FRAME, this.tick);
            addEventListener(MouseEvent.MOUSE_DOWN, this.clicked, true);
            return;
        }// end function

        override protected function controlRemoved(event:Event)
        {
            removeEventListener(Event.ENTER_FRAME, this.tick);
            removeEventListener(MouseEvent.MOUSE_DOWN, this.clicked, true);
            return;
        }// end function

        private function setupPoints() : void
        {
            this.checkShapePoints = new Array();
            this.checkShapePoints.push(new Point(this.checkboxWidth * 0.1, this.checkboxHeight * 0.55));
            this.checkShapePoints.push(new Point(this.checkboxWidth * 0.4, this.checkboxHeight * 0.9));
            this.checkShapePoints.push(new Point(this.checkboxWidth * 0.9, this.checkboxHeight * 0.1));
            this.checkShapePoints.push(new Point(this.checkboxWidth * 0.4, this.checkboxHeight * 0.75));
            return;
        }// end function

        protected function clicked(event:MouseEvent) : void
        {
            this.pressed = true;
            fadeTicks = fadeTicksMax;
            stage.addEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
            return;
        }// end function

        protected function mouseReleased(event:MouseEvent) : void
        {
            if (hover)
            {
                this.setChecked(!this.getChecked());
            }
            dispatchEvent(new CheckboxClickedEvent(this, hover));
            if (this.pressed)
            {
                this.pressed = false;
            }
            stage.removeEventListener(MouseEvent.MOUSE_UP, this.mouseReleased);
            return;
        }// end function

        public function getChecked() : Boolean
        {
            return this.checked;
        }// end function

        public function setChecked(param1:Boolean)
        {
            this.checked = param1;
            if (!this.checked)
            {
                ControlGraphics.clearGraphics(this.check);
            }
            this.refreshCheckbox();
            return;
        }// end function

        public function tick(event:Event) : void
        {
            this.refreshCheckbox();
            return;
        }// end function

        protected function refreshCheckbox() : void
        {
            ControlGraphics.drawRect(this.background, new Rectangle(0, 0, this.checkboxWidth, this.checkboxHeight), backgroundIdleCol);
            ControlGraphics.drawRect(this.background, new Rectangle(0, 0, this.checkboxWidth, this.checkboxHeight), backgroundHoverCol, outlineCol, fadeTicks / fadeTicksMax, outlineOpacity, outlineThickness, false);
            if (this.checked)
            {
                if (hover)
                {
                    ControlGraphics.drawPolygon(this.check, this.checkShapePoints, foregroundHoverCol, 0, 1, 0);
                }
                else
                {
                    ControlGraphics.drawPolygon(this.check, this.checkShapePoints, foregroundIdleCol, 0, 1, 0);
                }
            }
            return;
        }// end function

    }
}
