﻿package cust_Modules.Controls
{
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;

    public class Control extends MovieClip
    {
        protected var fadeTicks:int = 0;
        protected var fadeTicksMax:int = 15;
        protected var backgroundIdleCol:Number = 16777215;
        protected var backgroundHoverCol:Number = 1138570;
        protected var backgroundClickCol:Number = 1138570;
        protected var foregroundIdleCol:Number = 0;
        protected var foregroundHoverCol:Number = 16777215;
        protected var foregroundClickCol:Number = 0;
        protected var glyphIdleCol:Number = 1138570;
        protected var glyphHoverCol:Number = 4513279;
        protected var glyphClickCol:Number = 16777215;
        protected var outlineCol:Number = 0;
        protected var outlineOpacity:Number = 1;
        protected var outlineThickness:int = 1;
        protected var hover:Boolean = false;
        private var controlEnabled:Boolean = true;
        public var data:Object = null;
        public static var hoverControl:Control;

        public function Control()
        {
            addEventListener(Event.ADDED_TO_STAGE, this.addedToStage);
            return;
        }// end function

        private function addedToStage(event:Event)
        {
            addEventListener(Event.REMOVED_FROM_STAGE, this.removedFromStage);
            removeEventListener(Event.ADDED_TO_STAGE, this.addedToStage);
            addEventListener(Event.ENTER_FRAME, this.tickControl);
            stage.addEventListener(MouseEvent.MOUSE_WHEEL, this.mouseWheel);
            stage.addEventListener(MouseEvent.MOUSE_DOWN, this.controlClickedOff);
            addEventListener(MouseEvent.MOUSE_OVER, this.controlMouseOver);
            addEventListener(MouseEvent.MOUSE_OUT, this.controlMouseOut);
            addEventListener(MouseEvent.MOUSE_DOWN, this.controlClicked);
            this.controlAdded(event);
            return;
        }// end function

        private function removedFromStage(event:Event)
        {
            removeEventListener(Event.REMOVED_FROM_STAGE, this.removedFromStage);
            removeEventListener(Event.ENTER_FRAME, this.tickControl);
            stage.removeEventListener(MouseEvent.MOUSE_WHEEL, this.mouseWheel);
            stage.removeEventListener(MouseEvent.MOUSE_DOWN, this.controlClickedOff);
            removeEventListener(MouseEvent.MOUSE_OVER, this.controlMouseOver);
            removeEventListener(MouseEvent.MOUSE_OUT, this.controlMouseOut);
            removeEventListener(MouseEvent.MOUSE_DOWN, this.controlClicked);
            this.controlRemoved(event);
            return;
        }// end function

        protected function controlRemoved(event:Event)
        {
            return;
        }// end function

        protected function controlAdded(event:Event)
        {
            return;
        }// end function

        function controlClicked(event:MouseEvent) : void
        {
            return;
        }// end function

        private function controlMouseOver(event:MouseEvent)
        {
            if (hoverControl == null)
            {
                hoverControl = this;
            }
            this.hover = true;
            return;
        }// end function

        private function controlMouseOut(event:MouseEvent)
        {
            if (hoverControl == this)
            {
                hoverControl = null;
            }
            this.hover = false;
            return;
        }// end function

        function controlClickedOff(event:MouseEvent)
        {
            return;
        }// end function

        public function set _enabled(param1:Boolean) : void
        {
            var _loc_2:* = null;
            this.controlEnabled = param1;
            var _loc_3:* = 8 / 10;
            if (this.controlEnabled)
            {
                _loc_2 = new ColorTransform(1, 1, 1, 1);
            }
            else
            {
                _loc_2 = new ColorTransform(_loc_3, _loc_3, _loc_3, 1);
            }
            transform.colorTransform = _loc_2;
            mouseEnabled = this.controlEnabled;
            mouseChildren = this.controlEnabled;
            return;
        }// end function

        public function get _enabled() : Boolean
        {
            return this.controlEnabled;
        }// end function

        public function setBackIdleCol(param1:Number)
        {
            this.backgroundIdleCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setBackHoverCol(param1:Number)
        {
            this.backgroundHoverCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setBackClickCol(param1:Number)
        {
            this.backgroundClickCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setForeIdleCol(param1:Number)
        {
            this.foregroundIdleCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setForeHoverCol(param1:Number)
        {
            this.foregroundHoverCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setForeClickCol(param1:Number)
        {
            this.foregroundClickCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setGlyphIdleCol(param1:Number)
        {
            this.glyphIdleCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setGlyphHoverCol(param1:Number)
        {
            this.glyphHoverCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setGlyphClickCol(param1:Number)
        {
            this.glyphClickCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setOutlineCol(param1:Number)
        {
            this.outlineCol = param1;
            this.refreshControl();
            return;
        }// end function

        public function setOutlineThickness(param1:Number)
        {
            this.outlineThickness = param1;
            this.refreshControl();
            return;
        }// end function

        public function setOutlineOpacity(param1:Number)
        {
            this.outlineOpacity = param1;
            this.refreshControl();
            return;
        }// end function

        protected function refreshControl()
        {
            return;
        }// end function

        public function tickControl(event:Event) : void
        {
            this.fadeTicks = this.hover ? (this.fadeTicks < this.fadeTicksMax ? ((this.fadeTicks + 1)) : (this.fadeTicks)) : (this.fadeTicks > 0 ? (this.fadeTicks - 2) : (0));
            return;
        }// end function

        public function setTicksMax(param1:int) : void
        {
            this.fadeTicksMax = param1;
            param1 = Math.min(param1, this.fadeTicksMax);
            return;
        }// end function

        function mouseWheel(event:MouseEvent)
        {
            return;
        }// end function

    }
}
