﻿package Modules.Controls
{

    public class ListBox extends ScrollBox
    {
        private var items:Array;
        private var listboxWidth:Number;
        private var listboxHeight:Number;
        private var itemHeight:Number = 24;
        public var selectedItem:Object;

        public function ListBox(param1:Number, param2:Number)
        {
            super(param1, param2, 0, 0);
            this.listboxWidth = param1;
            this.listboxHeight = param2;
            this.items = new Array();
            return;
        }// end function

        public function get length()
        {
            return this.items.length;
        }// end function

        private function createNewButton(param1:String, param2:Object) : ListButton
        {
            var _loc_3:* = new ListButton(this.listboxWidth, this.itemHeight, param1, this);
            _loc_3.data = param2;
            _loc_3.setOutlineThickness(0);
            _loc_3.setBackHoverCol(2656445);
            _loc_3.setTicksMax(5);
            _loc_3.textLabel.setTextSize(13);
            return _loc_3;
        }// end function

        public function addItem(param1:String, param2:Object) : void
        {
            var _loc_3:* = this.createNewButton(param1, param2);
            sa.addObject(_loc_3, new Point(0, this.itemHeight * this.items.length));
            this.items.push(_loc_3);
            this.refreshItems();
            return;
        }// end function

        public function getItemAt(param1:int)
        {
            return this.items[param1];
        }// end function

        function notifyEvent(param1:ListButton)
        {
            this.selectedItem = param1;
            dispatchEvent(new ListBoxChangedEvent(param1));
            return;
        }// end function

        private function getItemFromObject(param1:Object) : Button
        {
            var _loc_2:* = 0;
            while (_loc_2 < this.items.length)
            {
                
                if (this.items[_loc_2].data == param1)
                {
                    return this.items[_loc_2];
                }
                _loc_2++;
            }
            return null;
        }// end function

        public function removeItem(param1:Object)
        {
            var _loc_3:* = undefined;
            var _loc_2:* = this.getItemFromObject(param1);
            if (_loc_2)
            {
                sa.removeObject(_loc_2);
                _loc_3 = this.items.indexOf(_loc_2);
                if (_loc_3 != -1)
                {
                    this.removeItemAt(_loc_3);
                }
            }
            this.refreshItems();
            return;
        }// end function

        public function removeAll()
        {
            var _loc_1:* = 0;
            while (_loc_1 < this.items.length)
            {
                
                sa.removeObject(this.items[_loc_1]);
                _loc_1++;
            }
            this.items = [];
            return;
        }// end function

        public function removeItemAt(param1:int)
        {
            sa.removeObject(this.items[param1]);
            this.items.splice(param1, 1);
            this.refreshItems();
            return;
        }// end function

        public function refreshItems()
        {
            var _loc_1:* = 0;
            while (_loc_1 < this.items.length)
            {
                
                this.items[_loc_1].y = _loc_1 * this.itemHeight;
                _loc_1++;
            }
            return;
        }// end function

        public function scrollToIndex(param1:int) : void
        {
            scrollToPosition(param1 * this.itemHeight + this.itemHeight / 2);
            return;
        }// end function

    }
}
