﻿package cust_Modules.Controls
{
    import flash.events.*;
    import flash.geom.*;

    public class ScrollBox extends Control
    {
        private var scrollbarHeight:int = 10;
        private var s:MarkerSlider;
        private var scrollboxWidth:Number;
        private var scrollboxHeight:Number;
        public var sa:ScrollableArea;

        public function ScrollBox(param1:Number, param2:Number, param3:int = 5, param4:int = 5)
        {
            this.scrollboxWidth = param1;
            this.scrollboxHeight = param2;
            this.sa = new ScrollableArea(this.scrollboxWidth, this.scrollboxHeight);
            this.sa.PADDING_BEFORE = param3;
            this.sa.PADDING_AFTER = param4;
            this.s = new MarkerSlider(this.scrollboxHeight, this.scrollbarHeight);
            this.s.x = this.scrollboxWidth + this.scrollbarHeight;
            this.s.rotation = 90;
            this.s.reverseScrollingDirection();
            addChild(this.sa);
            addChild(this.s);
            this.sa.scrollControl = this.s;
            this.s.addEventListener("sliderChanged", this.sliderChanged);
            ControlGraphics.drawRect(this.sa.hitbox, new Rectangle(0, 0, this.scrollboxWidth + this.scrollbarHeight, this.scrollboxHeight));
            return;
        }// end function

        override protected function controlRemoved(event:Event)
        {
            this.s.removeEventListener("sliderChanged", this.sliderChanged);
            return;
        }// end function

        public function setPaddingBefore(param1:int)
        {
            this.sa.PADDING_BEFORE = param1;
            return;
        }// end function

        public function setPaddingAfter(param1:int)
        {
            this.sa.PADDING_AFTER = param1;
            return;
        }// end function

        public function addObject(param1:Control, param2:Point)
        {
            this.sa.addObject(param1, param2);
            return;
        }// end function

        public function removeObject(param1:Control)
        {
            this.sa.removeObject(param1);
            return;
        }// end function

        public function sliderChanged(param1)
        {
            this.sa.scrollTo(param1.value);
            return;
        }// end function

        public function scrollToPosition(param1:Number)
        {
            this.sa.scrollTo(param1);
            this.s.setValue(param1 / this.sa.container.height);
            return;
        }// end function

    }
}
