﻿package cust_Modules.Controls
{
    import flash.display.*;
    import flash.events.*;
    import flash.geom.*;

    public class ScrollableArea extends Control
    {
        private var mouseInRegion:Object = false;
        public var PADDING_BEFORE:int = 5;
        public var PADDING_AFTER:int = 5;
        public var controls:Array;
        private var _scrollControl:Slider;
        private var scrollSpeed:int = 6;
        private var areaWidth:Number;
        private var areaHeight:Number;
        private var currentScroll:Number = 0;
        private var scrollTarget:Number = 0;
        public var container:MovieClip;
        private var areaMask:MovieClip;
        private var areaBorder:MovieClip;
        public var hitbox:MovieClip;

        public function ScrollableArea(param1:Number, param2:Number)
        {
            this.container = new MovieClip();
            this.areaMask = new MovieClip();
            this.areaBorder = new MovieClip();
            this.hitbox = new MovieClip();
            this.controls = new Array();
            addChild(this.container);
            addChild(this.areaMask);
            this.areaWidth = param1;
            this.areaHeight = param2;
            this.areaBorder.mouseEnabled = false;
            this.areaMask.mouseEnabled = false;
            this.setSize(param1, param2);
            this.container.mask = this.areaMask;
            ControlGraphics.drawRect(this.hitbox, new Rectangle(0, 0, param1, param2));
            this.hitbox.alpha = 0;
            this.hitbox.mouseEnabled = false;
            addChild(this.hitbox);
            ControlGraphics.drawRect(this.areaBorder, new Rectangle(0, 0, this.areaWidth, this.areaHeight), 0, 0, 0, 1);
            addChild(this.areaBorder);
            return;
        }// end function

        override protected function controlAdded(event:Event)
        {
            addEventListener(Event.ENTER_FRAME, this.tick);
            return;
        }// end function

        override protected function controlRemoved(event:Event)
        {
            removeEventListener(Event.ENTER_FRAME, this.tick);
            return;
        }// end function

        public function set scrollControl(param1:Slider)
        {
            this._scrollControl = param1;
            this._scrollControl._enabled = this.container.height > this.areaHeight;
            return;
        }// end function

        public function get scrollControl() : Slider
        {
            return this._scrollControl;
        }// end function

        public function addObject(param1:DisplayObject, param2:Point) : void
        {
            this.container.addChild(param1);
            param1.x = param2.x;
            param1.y = param2.y;
            this.controls.push(param1);
            if (this._scrollControl)
            {
                this._scrollControl._enabled = this.container.height > this.areaHeight;
            }
            return;
        }// end function

        public function removeObject(param1:DisplayObject) : void
        {
            if (param1.parent == this.container)
            {
                this.container.removeChild(param1);
            }
            this.controls.splice(this.controls.indexOf(param1), 1);
            if (this._scrollControl)
            {
                this._scrollControl._enabled = this.container.height > this.areaHeight;
            }
            return;
        }// end function

        public function setSize(param1:Number, param2:Number) : void
        {
            ControlGraphics.drawRect(this.areaMask, new Rectangle(0, 0, param1, param2));
            return;
        }// end function

        public function scrollToPix(param1:Number)
        {
            this.scrollTarget = Math.max(Math.min(param1, this.container.height), 0);
            return;
        }// end function

        public function scrollTo(param1:Number)
        {
            this.scrollTarget = param1 * (this.container.height - this.areaHeight + this.PADDING_BEFORE + this.PADDING_AFTER);
            return;
        }// end function

        public function tick(event:Event) : void
        {
            this.mouseInRegion = this.hitbox.hitTestPoint(stage.mouseX, stage.mouseY, false);
            var _loc_2:* = this.currentScroll - this.scrollTarget;
            if (Math.abs(_loc_2) < 0.05)
            {
                this.currentScroll = this.scrollTarget;
            }
            else
            {
                this.currentScroll = this.currentScroll + (this.scrollTarget - this.currentScroll);
            }
            this.currentScroll = Math.max(Math.min(this.currentScroll, this.container.height - this.areaHeight + this.PADDING_BEFORE + this.PADDING_AFTER), 0);
            this.currentScroll = this.currentScroll - this.PADDING_BEFORE;
            this.container.y = this.container.y + (-this.currentScroll - this.container.y) / 6;
            return;
        }// end function

        override function mouseWheel(event:MouseEvent)
        {
            if (this.mouseInRegion && this._scrollControl)
            {
                if (this._scrollControl._enabled)
                {
                    this._scrollControl.passMouseWheel(event);
                }
            }
            return;
        }// end function

    }
}
